<!DOCTYPE html>
<html lang="en">
<%- include('bases/head') -%>
<body>
<script>
    $(document).ready(function () {
        get_data()
    })

    function fill_edit_form(el) {
        let elements = $(el.parentNode.parentNode).find('[data-data]')
        for (let element of elements)
            $(`[name="${element.getAttribute('data-data')}"]`).val(element.innerHTML)
        $("#type").val('edit')
        $("#submit_btn").html('Изменить')
        $("#cancel_btn").prop('hidden', false)
        $("#edit_btn").prop('hidden', true)
    }

    function fill_create_form() {
        $("#type").val('create')
        $("#submit_btn").html('Добавить')
        $("#cancel_btn").prop('hidden', true)
        $("#edit_btn").prop('hidden', false)
    }

    function get_data() {
        $.ajax({
            url: '/api/records',
            dataType: 'json',
            method: 'GET'
        }).done(function (data) {
            let container = document.getElementById('container')
            let generated_html = ''
            for (let record of data) {
                generated_html += `<div class="card mb-3"><p data-data="id" hidden>${record['id']}</p>` +
                    `<h3 class="card-header" data-data="header">${record['header']}</h3><div class="card-body">` +
                    `<p class="card-text" data-data="body">${record['body']}</p></div><div class="card-body d-inline-flex">` +
                    `<button class="btn btn-outline-info" onclick="fill_edit_form(this)" type="button">Редактировать</button>` +
                    `<form method="post" class="ms-2"><input name="id" value="${record['id']}" hidden><input name="type" value="delete" hidden>` +
                    `<button class="btn btn-outline-danger" type="button" onclick="delete_note(this)">Удалить</button></form></div>` +
                    `<div class="card-footer text-muted" data-data="date">${record['date']}</div></div>`
            }
            $(container).html(generated_html)
        })
    }

    function delete_note(el) {
        let id = $(el.parentNode.parentNode.parentNode).find('[data-data="id"]').text()
        $.ajax({
            url: '/api/records/',
            data: {'id': id},
            method: 'DELETE',
        })
        $(el.parentNode.parentNode.parentNode).remove()
    }

    function edit_note() {
        let data = {}
        let elements = $("#form").find('[name]')
        for (let el of elements) {
            data[el.getAttribute('name')] = el.value
        }
        if (data['type'] === 'edit') {
            $.ajax({
                url: '/api/records/',
                method: 'PUT',
                data: data
            })
            $("#submit_btn").html('Добавить')
            get_data()
            $("#type").val('create')
        }
    }

    function create_note() {
        let data = {}
        let elements = $("#form").find('[name]')
        for (let el of elements) {
            data[el.getAttribute('name')] = el.value
        }
        if (data['type'] === 'create') {
            $.ajax({
                url: '/api/records/',
                method: 'POST',
                data: data
            })
            get_data()
        }
    }

    function sort_notes() {
        let order = $("#order").val()
        let field = $("#field").val()
        let name = $("#name").val()
        let records = get_all_notes()
        records.sort(function (a, b) {
            let x = a[field], y = b[field]
            if (order === 'asc')
                return ((x < y) ? -1 : ((x > y) ? 1 : 0))
            else return ((x > y) ? -1 : ((x < y) ? 1 : 0))
        })
        let ret = []
        if (name !== '') {
            for (let temp of records) {
                if (temp['header'].includes(name) || temp['body'].includes(name) || temp['date'].includes(name))
                    ret.push(temp)
            }
        } else ret = records

        let container = document.getElementById('container')
        let generated_html = ''
        for (let record of ret) {
            generated_html += `<div class="card mb-3"><p data-data="id" hidden>${record['id']}</p>` +
                `<h3 class="card-header" data-data="header">${record['header']}</h3><div class="card-body">` +
                `<p class="card-text" data-data="body">${record['body']}</p></div><div class="card-body d-inline-flex">` +
                `<button class="btn btn-outline-info" onclick="fill_edit_form(this)" type="button">Редактировать</button>` +
                `<form method="post" class="ms-2"><input name="id" value="${record['id']}" hidden><input name="type" value="delete" hidden>` +
                `<button class="btn btn-outline-danger" type="button" onclick="delete_note(this)">Удалить</button></form></div>` +
                `<div class="card-footer text-muted" data-data="date">${record['date']}</div></div>`
        }
        $(container).html(generated_html)
    }

    function get_all_notes() {
        let note_elements =$('#container').children()
        let data = []
        let tmp
        let fields
        for (let el of note_elements) {
            fields = $(el).find('[data-data]')
            tmp = {}
            for (let field of fields) {
                tmp[field.getAttribute('data-data')] = field.innerHTML
            }
            data.push(tmp)
        }
        return data
    }
</script>
<div class="d-flex justify-content-between w-75 m-auto vh-100 pt-5 flex-wrap row">
    <div class="col-lg-7">
        <form method="post" id="form">
            <input name="id" hidden>
            <input name="type" value="create" id="type" hidden>
            <div class="input-group">
                <input class="form-control form-control-lg" type="date" required name="date">
                <input class="form-control form-control-lg" type="text" placeholder="Заголовок..." name="header"
                       autocomplete="off">
            </div>
            <textarea class="form-control form-control-lg mt-3 no-resize" rows="10"
                      placeholder="Дорогой дневник..." name="body"></textarea>
            <div class="d-flex justify-content-around mt-3" id="form_buttons">
                <button class="btn btn-lg btn-outline-warning" type="reset" id="edit_btn" onclick="">Сбросить</button>
                <button class="btn btn-lg btn-outline-danger" type="reset" onclick="fill_create_form()" id="cancel_btn"
                        hidden>Отменить изменения
                </button>
                <button class="btn btn-lg btn-outline-success" type="reset" id="submit_btn" onclick="edit_note(); create_note()">Добавить</button>
            </div>
        </form>
        <form class="mt-5" method="get">
            <div class="input-group">
                <div class="input-group-text">Сортировка:</div>
                <input hidden name="type" value="sort">
                <select class="form-control" id="order">
                        <option value="asc">По возрастанию</option>
                        <option value="desc">По убыванию</option>
                </select>
                <select class="form-control" id="field">
                        <option value="header">Заголовка</option>
                        <option value="body">Содержания</option>
                        <option value="date">Даты</option>
                </select>
                <div class="input-group-text">Поиск:</div>
                <input class="form-control" id="name" autocomplete="off">
                <button class="btn btn-outline-primary" type="button" onclick="sort_notes()">Применить</button>
                <button class="btn btn-outline-warning" type="button"
                        onclick="window.location = window.location.href.split('?')[0]">Сбросить
                </button>
            </div>
        </form>
    </div>
    <div class="col-lg-5 h-75 overflow-auto" id="container">
    </div>
</div>
</body>
</html>